/*
 * 猫贝zblog小程序免费版 v1.0.1
 * Author: 猫贝
 */

const Api = require('../../utils/api');
const Util = require('../../utils/util');

Page({
  data: {
    scene: '',
    userInfo: {},
    hasUserInfo: false,
  },
  onLoad(query) {
    var scene = decodeURIComponent(query.scene)
    var e = wx.getStorageSync('CAT_USERINFO');
    if (e) {
      this.setData({
        userInfo: e,
        hasUserInfo: true,
        scene: scene
      });
    }
  },
  pcLogin: function () {
    var that = this;
    wx.login({
      success: function (res) {
        Util.get(Api.CAT_BEI_CUSTOM, {
          'act': 'status',
          'id': that.data.scene,
          'token': res.code
        }).then((res) => {
          if (res.data.code == 200) {
            wx.showToast({
              title: '操作成功！',
              icon: 'success',
              duration: 1500
            }), setTimeout(function () {
              wx.switchTab({
                url: '/pages/index/index'
              })
            }, 1500)
          } else {
            wx.showToast({
              title: res.data.data,
              icon: 'none',
              duration: 1500
            })
          }
        })
      }
    })
  }

})