/*
 * 猫贝zblog小程序免费版 v1.0.1
 * Author: 猫贝
 */

const Api = require('../../utils/api');
const Util = require('../../utils/util');
let videoAd = null;
let nowtimes = Date.parse(new Date()) / 1000;

Page({
  data: {
    hasUserInfo: false,
    isComment: false,
    comment_content: '',
    wxcode: "",
    comments: [],
    content: "",
    title: "",
    times: "",
    view: "",
    comm: "",
    img: "",
    page: 1,
    readHeight: '',
    id: 0
  },

  onLoad: function (options) {
    if (options.scene) {
      this.data.id = decodeURIComponent(options.scene);
    } else {
      this.data.id = options.id;
    }
    this.postart(this.data.id);
    this.postcom(this.data.id);
    this.loadWxacode(this.data.id);
    this.getAdvert();
  },

  postart: function (id) {
    var that = this;
    Util.get(Api.CAT_BEI_POST, {
      'act': 'get',
      'id': id,
      'viewnums' : '1'
    }).then(res => {
      wx.setNavigationBarTitle({
        title: res.data.data.post.Title,
      })
      that.setData({
        content: Util.replacestr(res.data.data.post.Content),
        title: res.data.data.post.Title,
        times: res.data.data.post.newTime,
        view: res.data.data.post.ViewNums,
        comm: res.data.data.post.CommNums,
        img: res.data.data.post.Thumb,
        tags: res.data.data.post.TagsName.split(","),
        id: res.data.data.post.ID,
        readHeight: res.data.data.post.Isread && wx.getStorageSync('adskey' + res.data.data.post.ID) + 1*24*60*60 < nowtimes ? '400rpx' : ''
      })
    })
  },

  postcom: function (id) {
    var that = this;
    Util.get(Api.CAT_BEI_COMM, {
      'act': 'list',
      'sortby': 'ID',
      'order': 'desc',
      //'with_relations': 'Author',
      'page': that.data.page,
      'post_id': id
    }).then(res => {
      that.setData({
        comments: res.data.data.list,
        allpage: res.data.data.pagebar.PageAll
      })
    })
  },

  loadpostcom: function () {
    var that = this;
    if (that.data.page != that.data.allpage && that.data.comments.length > 0) {
      Util.get(Api.CAT_BEI_COMM, {
        'act': 'list',
        'sortby': 'ID',
        'order': 'desc',
        'page': that.data.page + 1,
        'post_id': that.data.id,
      }).then(res => {
        that.setData({
          comments: that.data.comments.concat(res.data.data.list),
          allpage: res.data.data.pagebar.PageAll,
          page: res.data.data.pagebar.PageNow,
        })
      })
    }
  },

  getAdvert: function () {
    var that = this;
    Util.get(Api.CAT_BEI_CUSTOM, {
      'act': 'getads'
    }).then((res) => {
      if (wx.createRewardedVideoAd) {
        videoAd = wx.createRewardedVideoAd({
          adUnitId: res.data.data.con.rewardedid
        })
        videoAd.onError(err => {
          console.log(err);
        })
        videoAd.onClose((status) => {
          if (status && status.isEnded || status === undefined) {
            wx.setStorageSync('adskey' + that.data.id, nowtimes);
            that.setData({
              readHeight: ''
            })
          } else {
            wx.showModal({
              title: "提示",
              showCancel: false,
              content: "亲，需看完视频才可查看内容"
            });
          }
        })
      }
      that.setData({
        advert: res.data.data.con
      })
    })
  },

  onShow: function () {
    let u = wx.getStorageSync('CAT_LOGINUSER');
    if (u && u.expire_time > nowtimes) {
      this.setData({
        hasUserInfo: true
      });
    }
    var query = wx.createSelectorQuery();
    var that = this;
    query.select('.comedir-content').boundingClientRect(function (rect) {
      that.setData({
        comheight: rect.height
      })
    }).exec();
  },

  bindToEdit: function () {
    let that = this;
    wx.navigateTo({
      url: '/pages/editor/editor?id=' + that.data.id
    })
  },

  bindcontentinput: function (e) {
    this.setData({
      comment_content: e.detail.value
    });
  },

  bindcommentclick: function (e) {
    this.setData({
      comment_input: true
    });
  },

  bindcancelclick: function (e) {
    this.setData({
      comment_input: false
    });
  },

  postReadMore: function(){
    var that = this;
    videoAd.show().catch(() => {
      videoAd.load().then(() => videoAd.show()).catch(err => {
        console.log('激励视频 广告显示失败' + err);
        that.setData({
          readHeight: ''
        })
      })
    })
  },

  bindcommentpost: function (e) {
    let that = this;
    if (that.data.hasUserInfo) {
      wx.login({
        success: function (file) {
          Util.post(Api.CAT_BEI_CHECK, {
            'code': file.code,
            'content': that.data.comment_content
          }).then(res => {
            if (res.data.code == 200) {
              Util.post(Api.CAT_BEI_COMMPOST, {
                'postid': that.data.id,
                'content': that.data.comment_content,
              }).then(o => {
                wx.showToast({
                  title: "请等待审核",
                  icon: 'success',
                  duration: 1500
                }), setTimeout(function () {
                  that.postcom(that.data.id);
                  that.setData({
                    comment_input: false
                  })
                }, 1500)
              })
            } else {
              wx.showModal({
                title: '提示',
                showCancel: false,
                content: res.data.data,
                success(res) { }
              })
            }
          })
        }
      })
    } else {
      wx.showModal({
        title: '提示',
        content: '您当前未登录账号',
        success: function (res) {
          if (res.confirm) {
            wx.reLaunch({
              url: '/pages/auth/auth',
            })
          } else {
            that.setData({
              comment_input: false
            })
          }
        }
      })
    }
  },
  sharePosterClick: function () {
    var that = this;
    wx.showToast({
      title: '生成中...',
      icon: 'loading'
    });
    wx.createSelectorQuery()
      .select('#share')
      .fields({
        node: true,
        size: true,
      })
      .exec(function (res) {
        const canvas = res[0].node
        const context = canvas.getContext('2d')
        const width = res[0].width
        const height = res[0].height
        context.restore();
        const dpr = wx.getSystemInfoSync().pixelRatio
        canvas.width = width * dpr
        canvas.height = height * dpr
        context.scale(dpr, dpr)
        context.clearRect(0, 0, width, height);
        context.fillStyle = 'white'
        context.fillRect(0, 0, width, height)
        context.save();
        var path = that.data.img;
        const hbPromise = new Promise((resolve, reject) => {
          const hb = canvas.createImage()
          hb.onload = () => {
            resolve(hb)
          }
          hb.onerror = () => {
            reject(new Error(`fail to fetch image form: ${path}`))
          }
          hb.src = path
        })
        hbPromise.then(img => {
          context.drawImage(img, 0, 0, width, height * 0.4)
        })
        var codepath = that.data.wxcode;
        const codePromise = new Promise((resolve, reject) => {
          const code = canvas.createImage()
          code.onload = () => {
            resolve(code)
          }
          code.onerror = () => {
            reject(new Error(`fail to fetch image form: ${codepath}`))
          }
          code.src = codepath
        })
        codePromise.then(img => {
          context.drawImage(img, 120, height * 0.6, 120, 120)
        })
        context.fillStyle = '#333';
        var intro = "识别小程序，查看文章详情";
        context.font = 'normal 14px sans-serif';
        context.fillText(intro, 104, height * 0.95);
        var text = that.data.title;
        var chr = text.split("");
        var temp = "";
        var row = [];
        for (var a = 0; a < chr.length; a++) {
          if (context.measureText(temp).width < 280) {
            temp += chr[a];
          }
          else {
            a--;
            row.push(temp);
            temp = "";
          }
        }
        row.push(temp);
        if (row.length > 2) {
          var rowCut = row.slice(0, 2);
          var rowPart = rowCut[1];
          var test = "";
          var empty = [];
          for (var a = 0; a < rowPart.length; a++) {
            if (context.measureText(test).width < 280) {
              test += rowPart[a];
            }
            else {
              break;
            }
          }
          empty.push(test);
          var group = empty[0] + "..."
          rowCut.splice(1, 1, group);
          row = rowCut;
        }
        for (var b = 0; b < row.length; b++) {
          context.font = 'normal bold 16px sans-serif';
          context.fillText(row[b], 20, height * 0.48 + b * 30);
        }
        context.fillStyle = '#999';
        context.stroke();
        context.save();
        setTimeout(() => {
          that.toSave(canvas);
        }, 1000);
      });
  },

  loadWxacode: function (id) {
    let that = this;
    Util.get(Api.CAT_BEI_CUSTOM, {
      'act': 'wxcode',
      'postid': id
    }).then(res => {
      that.setData({
        wxcode: res.data.data
      })
    })
  },

  toSave(canvas) {
    let that = this
    wx.canvasToTempFilePath({
      x: 0,
      y: 0,
      canvasId: 'share',
      canvas: canvas,
      width: that.data.widths,
      height: that.data.heights,
      destWidth: that.data.widths * wx.getSystemInfoSync().pixelRatio,
      destHeight: that.data.heights * wx.getSystemInfoSync().pixelRatio,
      success: function (res) {
        let canvasToTempFilePath = res.tempFilePath
        wx.hideToast()
        that.saveShareImg(canvasToTempFilePath)
      },
      fail: function (error) {
        console.log(error)
      }
    })
  },

  saveShareImg: function (canvasToTempFilePath) {
    wx.getSetting({
      success(res) {
        wx.hideLoading({
          success: (res) => { },
          fail: (res) => {
            console.log(res)
          }
        })
        if (!res.authSetting['scope.writePhotosAlbum']) {
          wx.authorize({
            scope: 'scope.writePhotosAlbum',
            success() {
              wx.saveImageToPhotosAlbum({
                filePath: canvasToTempFilePath,
                success() {
                  wx.showToast({
                    title: '保存成功',
                    icon: 'success',
                    duration: 2000
                  })
                },
                fail() {
                  wx.showToast({
                    title: '保存失败',
                    icon: 'none'
                  })
                }
              })
            },
            fail() {
              wx.showModal({
                title: '提示',
                content: '请设置允许访问相册，否则将无法使用该功能',
                showCancel: false,
                success(res) {
                  if (res.confirm) {
                    console.log('用户点击确定')
                    wx.openSetting({
                      success(res) {
                        wx.saveImageToPhotosAlbum({
                          filePath: canvasToTempFilePath,
                          success() {
                            wx.showToast({
                              title: '保存成功',
                              icon: 'success',
                              duration: 2000
                            })
                          },
                          fail() {
                            wx.showToast({
                              title: '保存失败',
                              icon: 'error'
                            })
                          }
                        })
                      },
                      fail(err) {
                        console.log(err)
                      }
                    })
                  } else if (res.cancel) {
                    console.log('用户点击取消')
                  }
                }
              })
            }
          })
        }
        else {
          wx.saveImageToPhotosAlbum({
            filePath: canvasToTempFilePath,
            success() {
              wx.showToast({
                title: '保存成功',
                icon: 'success',
                duration: 2000
              })
            },
            fail() {
              wx.showToast({
                title: '保存失败',
                icon: 'error'
              })
            }
          })
        }
      },
      fail() { }
    });
  },

  onReachBottom: function () {
    this.loadpostcom();
  },

  onShareAppMessage: function () {
    let that = this;
    return {
      title: that.data.title,
      path: 'pages/post/post?id=' + that.data.id,
      imageUrl: that.data.img,
    }
  },

  onShareTimeline: function () {
    let that = this;
    return {
      title: that.data.title,
      path: 'pages/post/post?id=' + that.data.id,
    }
  }
})