/*
 * 猫贝zblog小程序免费版 v1.0.1
 * Author: 猫贝
 */

const Api = require('../../utils/api');
const Util = require('../../utils/util');

Page({
  data: {
    UserInfo: undefined,
    LoginUser: undefined,
    hasUserInfo: false,
    Level: 0,
  },
  onLoad: function () {
    this.getAdvert();
  },

  onShow: function () {
    let e = wx.getStorageSync('CAT_USERINFO');
    if (e) {
      this.setData({
        UserInfo: e,
        hasUserInfo: true,
      });
    }
    let u = wx.getStorageSync('CAT_LOGINUSER');
    if (u) {
      this.setData({
        Level: u.user.Level
      })
    }
  },

  getAdvert: function () {
    var that = this;
    Util.get(Api.CAT_BEI_CUSTOM, {
      'act': 'getads'
    }).then((res) => {
      that.setData({
        advert: res.data.data.con
      })
    })
  },

  getScancode: function () {
    wx.scanCode({
      onlyFromCamera: true,
      success: (res) => {
        if (res.scanType == "WX_CODE") {
          wx.navigateTo({
            url: "/" + res.path
          })
        } else {
          console.log(res);
        }
      }
    })
  },

  getEditor: function () {
    wx.navigateTo({
      url: '/pages/editor/editor'
    })
  },

  loginOut: function () {
    wx.showModal({
      title: '提示',
      content: '清除缓存 需要重新登录',
      success(res) {
        if (res.confirm) {
          wx.removeStorageSync("CAT_LOGINUSER");
          wx.removeStorageSync("CAT_USERINFO");
          wx.clearStorageSync();
          wx.showToast({
            title: '清除完毕',
          });
          wx.reLaunch({
            url: '/pages/index/index',
          })
        }
      }
    });
  }
})