/*
 * 猫贝zblog小程序免费版 v1.0.1
 * Author: 猫贝
 */

const Api = require('../../utils/api');
const Util = require('../../utils/util');

Page({
  data: {
    tips: "获取你的昵称、头像信息",
  },
  userLogin: function () {
    wx.getUserProfile({
      desc: this.data.tips,
      success: (e) => {
        wx.login({
          success: function (o) {
            Util.get(Api.CAT_BEI_CUSTOM, {
              'act': 'iscode',
              'code': o.code
            }).then((res) => {
              if (res.data.data == 200) {
                wx.login({
                  success: function (b) {
                    Util.get(Api.CAT_BEI_CUSTOM, {
                      'act': 'getlogin',
                      'code': b.code
                    }).then((res) => {
                      wx.setStorageSync('CAT_LOGINUSER', res.data.data);
                      wx.setStorageSync('CAT_USERINFO', e.userInfo);
                      wx.reLaunch({
                        url: '/pages/user/user',
                      })
                    })
                  }
                })
              } else {
                wx.showModal({
                  title: '',
                  content: '是否拥有本站账号',
                  confirmText: '我有',
                  cancelText: '没有',
                  success(res) {
                    if (res.confirm) {
                      wx.showToast({
                        title: '请在网站后台绑定账号',
                        icon: 'none',
                        duration: 1500
                      }), setTimeout(function () {
                        wx.reLaunch({
                          url: '/pages/user/user',
                        })
                      }, 1500)
                      wx.setStorageSync('CAT_USERINFO', e.userInfo);
                    } else if (res.cancel) {
                      wx.login({
                        success: function (t) {
                          Util.get(Api.CAT_BEI_CUSTOM, {
                            'act': 'getlogin',
                            'code': t.code,
                            'name': e.userInfo.nickName,
                            'img': e.userInfo.avatarUrl
                          }).then((res) => {
                            wx.setStorageSync('CAT_LOGINUSER', res.data.data);
                            wx.setStorageSync('CAT_USERINFO', e.userInfo);
                            wx.reLaunch({
                              url: '/pages/user/user',
                            })
                          })
                        }
                      })
                    }
                  }
                })
              }
            })
          }
        })
      }
    })
  },
  userLoginQ: function () {
    wx.reLaunch({
      url: '/pages/user/user',
    })
  }
})